--------------------------------------------------------------------------------------------------------------------------------------
--MUX                     |NAME   |Priority(1 highest)
--------------------------------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------
--      |MUX0    |MUX1	        |MUX2	           |MUX3	       |MUX4	            |MUX5	        |MUX6	     |MUX7                     |
--------------------------------------------------------------------------------------------------------------------------------------
--GPIO  |MIO     |ALT0	        |ALT1	           |ALT2	       |ALT3	            |ALT4	        |ALT5	     |RPi Rev2.0               |
--------------------------------------------------------------------------------------------------------------------------------------
--GPIO0 |MIO0  |x|SDA0        | |SA5           | |<reserved> | |                | |           | |          | |SDA0                 | |
--GPIO1 |MIO1  |x|SCL0        | |SA4           | |<reserved> | |                | |           | |          | |SCL0                 | |
--GPIO2 |MIO2  |x|SDA1        |x|SA3           | |<reserved> | |                | |           | |          | |SDA1                 |x|
--GPIO3 |MIO3  |x|SCL1        |x|SA2           | |<reserved> | |                | |           | |          | |SCL1                 |x|
--GPIO4 |MIO4  |x|GPCLK0      | |SA1           | |<reserved> | |                | |           | |ARM_TDI   | |GPIO_GCLK            | |
--GPIO5 |MIO5  |x|GPCLK1      | |SA0           | |<reserved> | |                | |           | |ARM_TDO   | |CAM_CLK              | |
--GPIO6 |MIO6  |x|GPCLK2      | |SOE_N / SE    | |<reserved> | |                | |           | |ARM_RTCK  | |LAN_RUN              | |
--GPIO7 |MIO7  |x|SPI0_CE1_N  |x|SWE_N / SRW_N | |<reserved> | |                | |           | |          | |SPI_CE1_N            |x|
--GPIO8 |MIO8  |x|SPI0_CE0_N  |x|SD0           | |<reserved> | |                | |           | |          | |SPI_CE0_N            |x|
--GPIO9 |MIO9  |x|SPI0_MISO   |x|SD1           | |<reserved> | |                | |           | |          | |SPI_MISO             |x|
--GPIO10|MIO10 |x|SPI0_MOSI   |x|SD2           | |<reserved> | |                | |           | |          | |SPI_MOSI             |x|
--GPIO11|MIO11 |x|SPI0_SCLK   |x|SD3           | |<reserved> | |                | |           | |          | |SPI_SCLK             |x|
--GPIO12|MIO12 |x|PWM0        |x|SD4           | |<reserved> | |                | |           | |ARM_TMS   | |nc                   | |
--GPIO13|MIO13 |x|PWM1        |x|SD5           | |<reserved> | |                | |           | |ARM_TCK   | |nc                   | |
--GPIO14|MIO14 |x|TXD0        |x|SD6           | |<reserved> | |                | |           | |TXD1      |x|TXD0                 |x|
--GPIO15|MIO15 |x|RXD0        |x|SD7           | |<reserved> | |                | |           | |RXD1      |x|RXD0                 |x|
--GPIO16|MIO16 |x|<reserved>  | |SD8           | |<reserved> | |CTS0            |x|SPI1_CE2_N |x|CTS1      |x|STATUS_LED_N         | |
--GPIO17|MIO17 |x|<reserved>  | |SD9           | |<reserved> | |RTS0            |x|SPI1_CE1_N |x|RTS1      |x|GPIO_GEN0            | |
--GPIO18|MIO18 |x|PCM_CLK     | |SD10          | |<reserved> | |BSCSL SDA / MOSI| |SPI1_CE0_N |x|PWM0      |x|GPIO_GEN1            | |
--GPIO19|MIO19 |x|PCM_FS      | |SD11          | |<reserved> | |BSCSL SCL / SCLK| |SPI1_MISO  |x|PWM1      |x|nc                   | |
--GPIO20|MIO20 |x|PCM_DIN     | |SD12          | |<reserved> | |BSCSL / MISO    | |SPI1_MOSI  |x|GPCLK0    | |nc                   | |
--GPIO21|MIO21 |x|PCM_DOUT    | |SD13          | |<reserved> | |BSCSL / CE_N    | |SPI1_SCLK  |x|GPCLK1    | |CAM_GPIO / GPIO_GEN2 | |
--GPIO22|MIO22 |x|<reserved>  | |SD14          | |<reserved> | |SD1_CLK         |x|ARM_TRST   | |          | |GPIO_GEN3            | |
--GPIO23|MIO23 |x|<reserved>  | |SD15          | |<reserved> | |SD1_CMD         |x|ARM_RTCK   | |          | |GPIO_GEN4            | |
--GPIO24|MIO24 |x|<reserved>  | |SD16          | |<reserved> | |SD1_DAT0        |x|ARM_TDO    | |          | |GPIO_GEN5            | |
--GPIO25|MIO25 |x|<reserved>  | |SD17          | |<reserved> | |SD1_DAT1        |x|ARM_TCK    | |          | |GPIO_GEN6            | |
--GPIO26|MIO26 |x|<reserved>  | |<reserved>    | |<reserved> | |SD1_DAT2        |x|ARM_TDI    | |          | |nc                   | |
--GPIO27|MIO27 |x|<reserved>  | |<reserved>    | |<reserved> | |SD1_DAT3        |x|ARM_TMS    | |          | |GPIO_GEN2 / CAM_GPIO | |
--------------------------------------------------------------------------------------------------------------------------------------
library IEEE;
    use IEEE.STD_LOGIC_1164.ALL;
    use ieee.numeric_std.all;

library work;
    use work.ALL;


entity rpi_gpio is 
generic (
  C_BOARD_VARIANT     : string  := "TE0726 REV X";
  C_MODI              : string  := "DYNAMIC";
  C_STATIC_MUX_VALUE  : std_logic_vector(32*8-1 downto 0)  := x"0000000000000000000000000000000000000000000000000000000000000000";
  C_EMIO_WIDTH        : integer range 32 to 64 := 32;
  C_GPIO_H_WIDTH      : integer range 12 to 12 := 12;
  C_EXCLUDE_I2C0      : integer range 0 to 1 := 0;
  C_EXCLUDE_UART0     : integer range 0 to 1 := 0
);
port ( 
  -- MUX
  MUX_CTRL_IN     : in std_logic_vector(32*8-1 downto 0);
  ----------------------------------------------------------
  --usr side
  --UART0
  CTS0_OUT            : out std_logic; 
  CRS0_IN             : in std_logic;
  
  RXD0_OUT            : out std_logic;
  TXD0_IN             : in  std_logic;
  --UART1 
  CTS1_OUT            : out std_logic;
  CRS1_IN             : in std_logic;
  
  RXD1_OUT            : out std_logic;
  TXD1_IN             : in  std_logic;
  --I2C1
  I2C1_SDA_I_OUT      : out std_logic;        
  I2C1_SDA_O_IN       : in  std_logic;
  I2C1_SDA_T_IN       : in  std_logic;
  
  I2C1_SCL_I_OUT      : out std_logic;        
  I2C1_SCL_O_IN       : in  std_logic;
  I2C1_SCL_T_IN       : in  std_logic;
  --SPI0
  SPI0_SCLK_I_OUT     : out std_logic;
  SPI0_SCLK_O_IN      : in  std_logic;
  SPI0_SCLK_T_IN      : in  std_logic;
  
  SPI0_IO0_MOSI_I_OUT     : out std_logic;
  SPI0_IO0_MOSI_O_IN      : in  std_logic;
  SPI0_IO0_MOSI_T_IN      : in  std_logic;
  
  SPI0_IO1_MISO_I_OUT     : out std_logic;
  SPI0_IO1_MISO_O_IN      : in  std_logic;
  SPI0_IO1_MISO_T_IN      : in  std_logic;
  
  SPI0_SS_I_OUT       : out std_logic;
  SPI0_SS_O_IN        : in  std_logic;
  SPI0_SS_T_IN        : in  std_logic;
  
  
  SPI0_SS1_O_IN       : in  std_logic;
  SPI0_SS2_O_IN       : in  std_logic;
  --SPI1
  SPI1_SCLK_I_OUT     : out std_logic;
  SPI1_SCLK_O_IN      : in  std_logic;
  SPI1_SCLK_T_IN      : in  std_logic;
    
  SPI1_IO0_MOSI_I_OUT     : out std_logic;
  SPI1_IO0_MOSI_O_IN      : in  std_logic;
  SPI1_IO0_MOSI_T_IN      : in  std_logic;
    
  SPI1_IO1_MISO_I_OUT     : out std_logic;
  SPI1_IO1_MISO_O_IN      : in  std_logic;
  SPI1_IO1_MISO_T_IN      : in  std_logic;
    
  SPI1_SS_I_OUT       : out std_logic;
  SPI1_SS_O_IN        : in  std_logic;
  SPI1_SS_T_IN        : in  std_logic;
  
  SPI1_SS1_O_IN       : in  std_logic;
  SPI1_SS2_O_IN       : in  std_logic;
  --SDIO
  SDIO0_CLK_IN        : in  std_logic;
  
  SDIO0_CMD_I_OUT     : out std_logic;
  SDIO0_CMD_O_IN      : in  std_logic;
  SDIO0_CMD_T_IN      : in  std_logic;
  
  SDIO0_DATA_I_OUT    : out std_logic_vector(3 downto 0);
  SDIO0_DATA_O_IN     : in  std_logic_vector(3 downto 0);
  SDIO0_DATA_T_IN     : in  std_logic_vector(3 downto 0);
  
  SDIO0_CDN_OUT       : out std_logic;
  
  --PWM
  PWM0_IN             : in  std_logic;
  PWM1_IN             : in  std_logic;
  --EMIO
  EMIO_O_IN           : in  std_logic_vector(C_EMIO_WIDTH-1 downto 0);
  EMIO_T_IN           : in  std_logic_vector(C_EMIO_WIDTH-1 downto 0);
  EMIO_I_OUT          : out std_logic_vector(C_EMIO_WIDTH-1 downto 0);
  ----------------------------------------------------------
  --gpio side
  --gpios
  GPIO_H_O_OUT        : out std_logic_vector(C_GPIO_H_WIDTH+15 downto 16);
  GPIO_H_T_OUT        : out std_logic_vector(C_GPIO_H_WIDTH+15 downto 16);
  GPIO_H_I_IN         : in  std_logic_vector(C_GPIO_H_WIDTH+15 downto 16);

  GPIO_L_O_OUT        : out std_logic_vector((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2);
  GPIO_L_T_OUT        : out std_logic_vector((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2);
  GPIO_L_I_IN         : in  std_logic_vector((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2)
);
end rpi_gpio;

architecture Behavioral of rpi_gpio is
constant C_MUX_WIDTH      : integer range 3 to 3 := 3;

--todo to generics as advanced generic:
--all gpio outputs
constant MUX_GPIO_WIDTH   : integer :=  C_GPIO_H_WIDTH+16;
--component groups for gpio inputs

function group_gpio_i_func( group_id : integer; get_offset : boolean) return integer is
--all elemets (only fabric outputs)
variable UART0 :integer := 2;
variable UART1 :integer := 2;
variable I2C1 :integer := 2;
variable SPI0 :integer := 4;
variable SPI1 :integer := 4;
variable SDIO :integer := 6;
variable PWM :integer := 0;
variable EMIO :integer := C_EMIO_WIDTH;
--whole size
variable tmp :integer := 0;
begin
  if (C_EMIO_WIDTH>MUX_GPIO_WIDTH) then
    EMIO  :=  MUX_GPIO_WIDTH;
  end if;
  case group_id is
    when 0 =>
      --UART0
      if (get_offset = TRUE ) then
        tmp :=0;
      else
        tmp:= UART0;
      end if;
    when 1 =>
      --UART1
      if (get_offset = TRUE ) then
        tmp:= UART0;
      else
        tmp := UART1;
      end if;
    when 2 =>
      --I2C1
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1;
      else
        tmp := I2C1;
      end if;
    when 3 =>
      --SPI0
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1+I2C1;
      else
        tmp := SPI0;
      end if;
    when 4 =>
      --SPI1
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1+I2C1+SPI0;
      else
        tmp := SPI1;
      end if;
    when 5 =>
      --SDIO
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1+I2C1+SPI0+SPI1;
      else
        tmp := SDIO;
      end if;
    when 6 =>
      --PWM
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1+I2C1+SPI0+SPI1+SDIO;
      else
        tmp := PWM;
      end if;
    when 7 =>
      --EMIO
      if (get_offset = TRUE ) then
        tmp:= UART0+UART1+I2C1+SPI0+SPI1+SDIO+PWM;
      else
        tmp := EMIO;
      end if;
    when others=>
      --return groupcount
        tmp:= UART0+UART1+I2C1+SPI0+SPI1+SDIO+PWM+EMIO;
  end case;
  return tmp;
end;

                                
signal mux_gpio_o_i : std_logic_vector(MUX_GPIO_WIDTH-1 downto 0);
signal mux_gpio_t_i : std_logic_vector(MUX_GPIO_WIDTH-1 downto 0);
signal mux_gpio_i_i : std_logic_vector(MUX_GPIO_WIDTH-1 downto 0);

signal mux_usr_o_i : std_logic_vector(MUX_GPIO_WIDTH*(2**C_MUX_WIDTH)-1 downto 0);
signal mux_usr_t_i : std_logic_vector(MUX_GPIO_WIDTH*(2**C_MUX_WIDTH)-1 downto 0);
                                

signal mux_ctrl_in_i : std_logic_vector(MUX_GPIO_WIDTH*C_MUX_WIDTH-1 downto 0);


--todo mapping from mux_ctrl_in_i to mux_group_ctrl_i

signal mux_group_ctrl_i : std_logic_vector(group_gpio_i_func(-1,FALSE)*C_MUX_WIDTH-1 downto 0);
signal mux_group_usr_i_i : std_logic_vector(group_gpio_i_func(-1,FALSE)-1 downto 0);
signal mux_group_gpio_i_i : std_logic_vector(group_gpio_i_func(-1,FALSE)*(2**C_MUX_WIDTH)-1 downto 0);
begin
  ------------------------------------------
  --giop connection:
  GPIO_L_O_OUT <= mux_gpio_o_i((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2);
  GPIO_L_T_OUT <= mux_gpio_t_i((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2);
  mux_gpio_i_i((15 - C_EXCLUDE_UART0*2) downto C_EXCLUDE_I2C0*2) <= GPIO_L_I_IN;
  --
  GPIO_H_O_OUT <= mux_gpio_o_i(C_GPIO_H_WIDTH+15 downto 16);
  GPIO_H_T_OUT <= mux_gpio_t_i(C_GPIO_H_WIDTH+15 downto 16);
  mux_gpio_i_i(C_GPIO_H_WIDTH+15 downto 16) <= GPIO_H_I_IN;
  --
  uart0_exclude_gen: for index in 15 downto 15 - (C_EXCLUDE_UART0*2)+1 generate
   -- GPIO_L_O_OUT(index)     <= '0';
   -- GPIO_L_T_OUT(index)     <= '0';
   mux_gpio_i_i(index) <= '0';
  end generate;
  --
  i2c0_exclude_gen: for index in 1 downto 1 - (C_EXCLUDE_I2C0*2)+1 generate
   -- GPIO_L_O_OUT(index)     <= '0';
   -- GPIO_L_T_OUT(index)     <= '0';
   mux_gpio_i_i(index) <= '0';
  end generate;
  
board_TE0726_X_gen: if (C_BOARD_VARIANT="TE0726 REV X") generate

  -------------------------------------------------------------------
  dyn_mux_gen: if(C_MODI="DYNAMIC") generate
    --MUX
    gpio_mux_gen: for index_g in 0 to MUX_GPIO_WIDTH-1 generate
      --4aus8
                                            --32IO, 8Bit for coding
      --MUX_CTRL_IN     : in std_logic_vector(32*8-1 downto 0);
      mux_ctrl_in_i((index_g+1)*C_MUX_WIDTH-1 downto index_g*C_MUX_WIDTH)<=MUX_CTRL_IN(index_g*8+C_MUX_WIDTH-1 downto index_g*8);
    end generate;
  end generate;
  stat_mux_gen: if(C_MODI="STATIC") generate
    gpio_mux_gen: for index_g in 0 to MUX_GPIO_WIDTH-1 generate
      --4aus8
                                            --32IO, 8Bit for coding
      --MUX_CTRL_IN     : in std_logic_vector(32*8-1 downto 0);
      mux_ctrl_in_i((index_g+1)*C_MUX_WIDTH-1 downto index_g*C_MUX_WIDTH) <= C_STATIC_MUX_VALUE(index_g*8+C_MUX_WIDTH-1 downto index_g*8);
    end generate;
  end generate;
  -------------------------------------------------------------------
  --GPIO out
  gpio_gen: for index_g in 0 to MUX_GPIO_WIDTH-1 generate
    gpio_mux_proc: process(mux_usr_o_i,mux_usr_t_i)
    begin
      mux_gpio_o_i(index_g) <= mux_usr_o_i(index_g*(2**C_MUX_WIDTH)+0); 
      mux_gpio_t_i(index_g) <= mux_usr_t_i(index_g*(2**C_MUX_WIDTH)+0);
      for index_m in 1 to (2**C_MUX_WIDTH)-1 loop
        if(mux_ctrl_in_i((index_g+1)*C_MUX_WIDTH-1 downto index_g*C_MUX_WIDTH)=std_logic_vector(to_unsigned(index_m,C_MUX_WIDTH))) then
          mux_gpio_o_i(index_g) <= mux_usr_o_i(index_g*(2**C_MUX_WIDTH)+index_m); 
          mux_gpio_t_i(index_g) <= mux_usr_t_i(index_g*(2**C_MUX_WIDTH)+index_m);
          exit;
        end if;
      end loop;
    end process;
  end generate;
  -------------------------------------------------------------------
  --group gpio in
  group_gen: for index_g in 0 to group_gpio_i_func(-1,FALSE)-1 generate
    gpio_mux_proc: process(mux_group_gpio_i_i,mux_group_ctrl_i)
    begin
      mux_group_usr_i_i(index_g) <= mux_group_gpio_i_i(index_g*(2**C_MUX_WIDTH)+0); 
      for index_m in 1 to (2**C_MUX_WIDTH)-1 loop
        if(mux_group_ctrl_i((index_g+1)*C_MUX_WIDTH-1 downto index_g*C_MUX_WIDTH)=std_logic_vector(to_unsigned(index_m,C_MUX_WIDTH))) then
          mux_group_usr_i_i(index_g) <= mux_group_gpio_i_i(index_g*(2**C_MUX_WIDTH)+index_m); 
          exit;
        end if;
      end loop;
    end process;
  end generate;
  -------------------------------------------------------------------
  --gpio in
  ---------------------
    --group 0 uart0
    CTS0_OUT            <= mux_group_usr_i_i(group_gpio_i_func(0,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(0,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(0,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((16+1)*C_MUX_WIDTH-1 downto 16*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(16); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    RXD0_OUT            <= mux_group_usr_i_i(group_gpio_i_func(0,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(0,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(0,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((15+1)*C_MUX_WIDTH-1 downto 15*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(15); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(0,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(15); 
    --group 1 uart1
    CTS1_OUT            <= mux_group_usr_i_i(group_gpio_i_func(1,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(1,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(1,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(6,C_MUX_WIDTH)) when (mux_ctrl_in_i((16+1)*C_MUX_WIDTH-1 downto 16*C_MUX_WIDTH)=std_logic_vector(to_unsigned(6,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= mux_gpio_i_i(16);
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    RXD1_OUT            <= mux_group_usr_i_i(group_gpio_i_func(1,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(1,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(1,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(6,C_MUX_WIDTH)) when (mux_ctrl_in_i((15+1)*C_MUX_WIDTH-1 downto 15*C_MUX_WIDTH)=std_logic_vector(to_unsigned(6,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= mux_gpio_i_i(15); 
    mux_group_gpio_i_i((group_gpio_i_func(1,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --group 2 I2C1
    I2C1_SDA_I_OUT      <= mux_group_usr_i_i(group_gpio_i_func(2,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(2,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(2,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((2+1)*C_MUX_WIDTH-1 downto 2*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(2);
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(2);
    --
    I2C1_SCL_I_OUT      <= mux_group_usr_i_i(group_gpio_i_func(2,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(2,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(2,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((3+1)*C_MUX_WIDTH-1 downto 3*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(3);
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(2,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(3);
    --group 3 SPI0
    SPI0_SCLK_I_OUT     <= mux_group_usr_i_i(group_gpio_i_func(3,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(3,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(3,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((11+1)*C_MUX_WIDTH-1 downto 11*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(11);
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(11);
    --
    SPI0_IO0_MOSI_I_OUT <= mux_group_usr_i_i(group_gpio_i_func(3,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(3,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(3,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((10+1)*C_MUX_WIDTH-1 downto 10*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(10);
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(10);
    --
    SPI0_IO1_MISO_I_OUT <= mux_group_usr_i_i(group_gpio_i_func(3,TRUE)+2); 
    mux_group_ctrl_i(((group_gpio_i_func(3,TRUE)+2)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(3,TRUE)+2)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((9+1)*C_MUX_WIDTH-1 downto 9*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(9);
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+2)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(9);
    --
    SPI0_SS_I_OUT       <= mux_group_usr_i_i(group_gpio_i_func(3,TRUE)+3); 
    mux_group_ctrl_i(((group_gpio_i_func(3,TRUE)+3)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(3,TRUE)+3)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(1,C_MUX_WIDTH)) when (mux_ctrl_in_i((8+1)*C_MUX_WIDTH-1 downto 8*C_MUX_WIDTH)=std_logic_vector(to_unsigned(1,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+1) <= mux_gpio_i_i(8); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(3,TRUE)+3)*(2**C_MUX_WIDTH)+7) <= mux_gpio_i_i(8); 
    --group 4 SPI1
    SPI1_SCLK_I_OUT     <= mux_group_usr_i_i(group_gpio_i_func(4,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(4,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(4,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(5,C_MUX_WIDTH)) when (mux_ctrl_in_i((21+1)*C_MUX_WIDTH-1 downto 21*C_MUX_WIDTH)=std_logic_vector(to_unsigned(5,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= mux_gpio_i_i(21); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SPI1_IO0_MOSI_I_OUT <= mux_group_usr_i_i(group_gpio_i_func(4,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(4,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(4,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(5,C_MUX_WIDTH)) when (mux_ctrl_in_i((20+1)*C_MUX_WIDTH-1 downto 20*C_MUX_WIDTH)=std_logic_vector(to_unsigned(5,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= mux_gpio_i_i(20);
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SPI1_IO1_MISO_I_OUT <= mux_group_usr_i_i(group_gpio_i_func(4,TRUE)+2); 
    mux_group_ctrl_i(((group_gpio_i_func(4,TRUE)+2)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(4,TRUE)+2)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(5,C_MUX_WIDTH)) when (mux_ctrl_in_i((19+1)*C_MUX_WIDTH-1 downto 19*C_MUX_WIDTH)=std_logic_vector(to_unsigned(5,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+5) <= mux_gpio_i_i(19);
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+2)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SPI1_SS_I_OUT       <= mux_group_usr_i_i(group_gpio_i_func(4,TRUE)+3); 
    mux_group_ctrl_i(((group_gpio_i_func(4,TRUE)+3)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(4,TRUE)+3)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(5,C_MUX_WIDTH)) when (mux_ctrl_in_i((18+1)*C_MUX_WIDTH-1 downto 18*C_MUX_WIDTH)=std_logic_vector(to_unsigned(5,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+5) <= mux_gpio_i_i(18);
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(4,TRUE)+3)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --group 5 SDIO
    SDIO0_CMD_I_OUT     <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+0); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((23+1)*C_MUX_WIDTH-1 downto 23*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(23);
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SDIO0_DATA_I_OUT(0) <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+1); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+1)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+1)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((24+1)*C_MUX_WIDTH-1 downto 24*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(24);
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+1)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SDIO0_DATA_I_OUT(1) <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+2); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+2)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+2)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((25+1)*C_MUX_WIDTH-1 downto 25*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(25);
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+2)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SDIO0_DATA_I_OUT(2) <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+3); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+3)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+3)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((26+1)*C_MUX_WIDTH-1 downto 26*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(26);
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+3)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SDIO0_DATA_I_OUT(3) <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+4); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+4)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+4)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((27+1)*C_MUX_WIDTH-1 downto 27*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+4) <= mux_gpio_i_i(27);
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+4)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    SDIO0_CDN_OUT <= mux_group_usr_i_i(group_gpio_i_func(5,TRUE)+5); 
    mux_group_ctrl_i(((group_gpio_i_func(5,TRUE)+5)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(5,TRUE)+5)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(4,C_MUX_WIDTH)) when (mux_ctrl_in_i((23+1)*C_MUX_WIDTH-1 downto 23*C_MUX_WIDTH)=std_logic_vector(to_unsigned(4,C_MUX_WIDTH))) 
                                                                                                                          else (others => '1');
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+0) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+4) <= '0'; --enable card detect only on mux4
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
    mux_group_gpio_i_i((group_gpio_i_func(5,TRUE)+5)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???); 
    --
    --group 6 PWM
         -- <= mux_group_usr_i_i(group_gpio_i_func(6,TRUE)+0); 
    -- mux_group_ctrl_i(((group_gpio_i_func(6,TRUE)+0)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(6,TRUE)+0)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(0,C_MUX_WIDTH)) when (mux_ctrl_in_i((xx+1)*C_MUX_WIDTH-1 downto xx*C_MUX_WIDTH)=std_logic_vector(to_unsigned(0,C_MUX_WIDTH))) 
                                                                                                                          -- else (others => '0');
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+0) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+1) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+2) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+3) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+4) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+5) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+6) <= '0';--mux_gpio_i_i(???); 
    -- mux_group_gpio_i_i((group_gpio_i_func(6,TRUE)+0)*(2**C_MUX_WIDTH)+7) <= '0';--mux_gpio_i_i(???); 
    --group 7 EMIO
    emio_smaller_eq_gen: if(C_EMIO_WIDTH <= MUX_GPIO_WIDTH) generate
      gpio_in_emio_gen: for index in 0 to C_EMIO_WIDTH-1 generate
        EMIO_I_OUT(index) <= mux_group_usr_i_i(group_gpio_i_func(7,TRUE)+index); 
        mux_group_ctrl_i(((group_gpio_i_func(7,TRUE)+index)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(7,TRUE)+index)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(0,C_MUX_WIDTH)) when (mux_ctrl_in_i((index+1)*C_MUX_WIDTH-1 downto index*C_MUX_WIDTH)=std_logic_vector(to_unsigned(0,C_MUX_WIDTH))) 
                                                                      else (others => '1');
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+0) <= mux_gpio_i_i(index);--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???);                                                 
      end generate;
    end generate;
    emio_greater_gen: if(C_EMIO_WIDTH > MUX_GPIO_WIDTH) generate
      gpio_in_emio_gen: for index in 0 to MUX_GPIO_WIDTH-1 generate
        EMIO_I_OUT(index) <= mux_group_usr_i_i(group_gpio_i_func(7,TRUE)+index); 
        mux_group_ctrl_i(((group_gpio_i_func(7,TRUE)+index)+1)*C_MUX_WIDTH-1 downto (group_gpio_i_func(7,TRUE)+index)*C_MUX_WIDTH) <= std_logic_vector(to_unsigned(0,C_MUX_WIDTH)) when (mux_ctrl_in_i((index+1)*C_MUX_WIDTH-1 downto index*C_MUX_WIDTH)=std_logic_vector(to_unsigned(0,C_MUX_WIDTH))) 
                                                                      else (others => '1');
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+0) <= mux_gpio_i_i(index);--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+1) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+2) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+3) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+4) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+5) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+6) <= '1';--mux_gpio_i_i(???); 
        mux_group_gpio_i_i((group_gpio_i_func(7,TRUE)+index)*(2**C_MUX_WIDTH)+7) <= '1';--mux_gpio_i_i(???);                                                 
      end generate;
      emio_unused_gen: for index in MUX_GPIO_WIDTH to C_EMIO_WIDTH-1 generate
        EMIO_I_OUT(index) <= '0';
      end generate;
    end generate;
  -------------------------------------------------------------------
  --gpio out
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 0);
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+1) <='0';--SDA0
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+2) <='0';--SA5
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 0*(2**C_MUX_WIDTH)+7) <='0';--
  --           
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 0);
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+1) <='1';--SDA0
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+2) <='1';--SA5
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 0*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 1);
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+1) <='0';--SCL0
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+2) <='0';--SA4
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 1*(2**C_MUX_WIDTH)+7) <='0';--
  --           1                     
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 1);
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+1) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+2) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+3) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 1*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 2);
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+1) <= I2C1_SDA_O_IN;--SDA1
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+2) <='0';--SA3
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 2*(2**C_MUX_WIDTH)+7) <= I2C1_SDA_O_IN;--SDA1
  --           2                     
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 2);
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+1) <= I2C1_SDA_T_IN;--SDA1
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+2) <='1';--SA3
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 2*(2**C_MUX_WIDTH)+7) <= I2C1_SDA_T_IN;--SDA1
   
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 3);
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+1) <= I2C1_SCL_O_IN;--SCL1
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+2) <='0';--SA2
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 3*(2**C_MUX_WIDTH)+7) <= I2C1_SCL_O_IN;--SCL1
  --           3                     
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 3);
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+1) <= I2C1_SCL_T_IN;--SCL1
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+2) <='1';--SA2
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 3*(2**C_MUX_WIDTH)+7) <= I2C1_SCL_T_IN;--SCL1

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 4);
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+1) <='0';--GPCLK0
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+2) <='0';--SA1
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+6) <='0';--ARM_TDI
  mux_usr_o_i( 4*(2**C_MUX_WIDTH)+7) <='0';--
  --           4                     
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 4);
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+1) <='1';--GPCLK0
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+2) <='1';--SA1
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+6) <='1';--ARM_TDI
  mux_usr_t_i( 4*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 5);
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+1) <='0';--GPCLK1 / CAM_CLK
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+2) <='0';--SA0
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+6) <='0';--ARM_TDO
  mux_usr_o_i( 5*(2**C_MUX_WIDTH)+7) <='0';--
  --           5                     
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 5);
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+1) <='1';--GPCLK1 / CAM_CLK
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+2) <='1';--SA0
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+6) <='1';--ARM_TDO
  mux_usr_t_i( 5*(2**C_MUX_WIDTH)+7) <='1';--
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 6);
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+1) <='0';--GPCLK2 /LAN_RUN
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+2) <='0';--SOE_N / SE
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+6) <='0';--ARM_RTCK
  mux_usr_o_i( 6*(2**C_MUX_WIDTH)+7) <='0';--
  --           6                     
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 6);
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+1) <='1';--GPCLK2 /LAN_RUN
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+2) <='1';--SOE_N / SE
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+6) <='1';--ARM_RTCK
  mux_usr_t_i( 6*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 7);
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+1) <= SPI0_SS1_O_IN;--SPI0_CE1_N
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+2) <='0';--SWE_N / SRW_N
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 7*(2**C_MUX_WIDTH)+7) <= SPI0_SS1_O_IN;--SPI0_CE1_N
  --           7                     
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 7);
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+1) <= '0';--SPI0_CE1_N
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+2) <='1';--SWE_N / SRW_N
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 7*(2**C_MUX_WIDTH)+7) <= '0';--SPI0_CE1_N

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 8);
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+1) <= SPI0_SS_O_IN;--SPI0_CE0_N
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+2) <='0';--SD0
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 8*(2**C_MUX_WIDTH)+7) <= SPI0_SS_O_IN;--SPI0_CE0_N
  --           8                     
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 8);
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+1) <= SPI0_SS_T_IN;--SPI0_CE0_N
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+2) <='1';--SD0
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 8*(2**C_MUX_WIDTH)+7) <= SPI0_SS_T_IN;--SPI0_CE0_N

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN( 9);
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+1) <= SPI0_IO1_MISO_O_IN;--SPI0_MISO
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+2) <='0';--SD1
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i( 9*(2**C_MUX_WIDTH)+7) <= SPI0_IO1_MISO_O_IN;--SPI0_MISO
  --           9                     
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN( 9);
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+1) <= SPI0_IO1_MISO_T_IN;--SPI0_MISO
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+2) <='1';--SD1
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i( 9*(2**C_MUX_WIDTH)+7) <= SPI0_IO1_MISO_T_IN;--SPI0_MISO

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(10);
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+1) <= SPI0_IO0_MOSI_O_IN;--SPI0_MOSI
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+2) <='0';--SD2
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(10*(2**C_MUX_WIDTH)+7) <= SPI0_IO0_MOSI_O_IN;--SPI0_MOSI
  --          10                     
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(10);
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+1) <= SPI0_IO0_MOSI_T_IN;--SPI0_MOSI
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+2) <='1';--SD2
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(10*(2**C_MUX_WIDTH)+7) <= SPI0_IO0_MOSI_T_IN;--SPI0_MOSI

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(11);
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+1) <= SPI0_SCLK_O_IN;--SPI0_SCLK
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+2) <='0';--SD3
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(11*(2**C_MUX_WIDTH)+7) <= SPI0_SCLK_O_IN;--SPI0_SCLK
  --          11                     
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(11);
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+1) <= SPI0_SCLK_T_IN;--SPI0_SCLK
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+2) <='1';--SD3
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(11*(2**C_MUX_WIDTH)+7) <= SPI0_SCLK_T_IN;--SPI0_SCLK

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(12);
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+1) <= PWM0_IN;--PWM0 /nc
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+2) <='0';--SD4
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+6) <='0';--ARM_TMS
  mux_usr_o_i(12*(2**C_MUX_WIDTH)+7) <='0';--
  --          12                     
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(12);
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+1) <= '0';--PWM0 /nc
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+2) <='1';--SD4
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+6) <='1';--ARM_TMS
  mux_usr_t_i(12*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(13);
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+1) <= PWM1_IN;--PWM1 /nc
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+2) <='0';--SD5
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+6) <='0';--ARM_TCK
  mux_usr_o_i(13*(2**C_MUX_WIDTH)+7) <='0';--
  --          13                     
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(13);
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+1) <= '0';--PWM1 /nc
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+2) <='1';--SD5
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+6) <='1';--ARM_TCK
  mux_usr_t_i(13*(2**C_MUX_WIDTH)+7) <='1';--
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(14);
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+1) <= TXD0_IN;--TXD0
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+2) <='0';--SD6
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+6) <= TXD1_IN;--TXD1
  mux_usr_o_i(14*(2**C_MUX_WIDTH)+7) <= TXD0_IN;--TXD0
  --          14                     
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(14);
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+1) <= '0';--TXD0
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+2) <='1';--SD6
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+6) <='0';--TXD1
  mux_usr_t_i(14*(2**C_MUX_WIDTH)+7) <= '0';--TXD0

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(15);
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+1) <= '0';--RXD0
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+2) <='0';--SD7
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+4) <='0';--
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+5) <='0';--
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+6) <='0';--RXD1
  mux_usr_o_i(15*(2**C_MUX_WIDTH)+7) <='0';--RXD0
  --          15                     
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(15);
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+1) <= '1';--RXD0
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+2) <='1';--SD7
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+4) <='1';--
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+5) <='1';--
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+6) <='1';--RXD1
  mux_usr_t_i(15*(2**C_MUX_WIDTH)+7) <='1';--RXD0

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(16);
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+1) <='0';--<reserved> /STATUS_LED_N
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+2) <='0';--SD8
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+4) <= '0';--CTS0
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+5) <= SPI1_SS2_O_IN;--SPI1_CE2_N
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+6) <= '0';--CTS1
  mux_usr_o_i(16*(2**C_MUX_WIDTH)+7) <='0';--
  --          16                     
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(16);
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+1) <='1';--<reserved> /STATUS_LED_N
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+2) <='1';--SD8
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+4) <= '1';--CTS0
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+5) <= '0';--SPI1_CE2_N
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+6) <= '1';--CTS1
  mux_usr_t_i(16*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(17);
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+1) <='0';--<reserved> /GPIO_GEN0
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+2) <='0';--SD9
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+4) <= CRS0_IN;--RTS0
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+5) <= SPI1_SS1_O_IN;--SPI1_CE1_N
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+6) <= CRS1_IN;--RTS1
  mux_usr_o_i(17*(2**C_MUX_WIDTH)+7) <='0';--
  --          17                     
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(17);
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+1) <='1';--<reserved> /GPIO_GEN0
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+2) <='1';--SD9
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+4) <= '0';--RTS0
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+5) <= '0';--SPI1_CE1_N
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+6) <= '0';--RTS1
  mux_usr_t_i(17*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(18);
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+1) <='0';--PCM_CLK /GPIO_GEN1
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+2) <='0';--SD10
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+4) <='0';--BSCSL SDA / MOSI
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+5) <= SPI1_SS_O_IN;--SPI1_CE0_N
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+6) <= PWM0_IN;--PWM0
  mux_usr_o_i(18*(2**C_MUX_WIDTH)+7) <='0';--
  --          18                     
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(18);
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+1) <='1';--PCM_CLK /GPIO_GEN1
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+2) <='1';--SD10
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+4) <='1';--BSCSL SDA / MOSI
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+5) <= SPI1_SS_T_IN;--SPI1_CE0_N
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+6) <= '0';--PWM0
  mux_usr_t_i(18*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(19);
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+1) <='0';--PCM_FS / nc
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+2) <='0';--SD11
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+4) <='0';--BSCSL SCL / SCLK
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+5) <= SPI1_IO1_MISO_O_IN;--SPI1_MISO
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+6) <= PWM1_IN;--PWM1
  mux_usr_o_i(19*(2**C_MUX_WIDTH)+7) <='0';--
  --          19                     
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(19);
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+1) <='1';--PCM_FS / nc
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+2) <='1';--SD11
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+4) <='1';--BSCSL SCL / SCLK
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+5) <= SPI1_IO1_MISO_T_IN;--SPI1_MISO
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+6) <= '0';--PWM1
  mux_usr_t_i(19*(2**C_MUX_WIDTH)+7) <='1';--
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(20);
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+1) <='0';--PCM_DIN / nc
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+2) <='0';--SD12
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+4) <='0';--BSCSL / MISO
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+5) <= SPI1_IO0_MOSI_O_IN;--SPI1_MOSI
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+6) <='0';--GPCLK0
  mux_usr_o_i(20*(2**C_MUX_WIDTH)+7) <='0';--
  --          20                     
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(20);
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+1) <='1';--PCM_DIN / nc
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+2) <='1';--SD12
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+4) <='1';--BSCSL / MISO
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+5) <= SPI1_IO0_MOSI_T_IN;--SPI1_MOSI
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+6) <='1';--GPCLK0
  mux_usr_t_i(20*(2**C_MUX_WIDTH)+7) <='1';--
  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(21);
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+1) <='0';--PCM_DOUT / CAM_GPIO / GPIO_GEN2
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+2) <='0';--SD13
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+4) <='0';--BSCSL / CE_N
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+5) <= SPI1_SCLK_O_IN;--SPI1_SCLK
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+6) <='0';--GPCLK1
  mux_usr_o_i(21*(2**C_MUX_WIDTH)+7) <='0';--
  --          21                     
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(21);
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+1) <='1';--PCM_DOUT / CAM_GPIO / GPIO_GEN2
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+2) <='1';--SD13
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+4) <='1';--BSCSL / CE_N
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+5) <= SPI1_SCLK_T_IN;--SPI1_SCLK
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+6) <='1';--GPCLK1
  mux_usr_t_i(21*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(22);
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+1) <='0';--<reserved>/GPIO_GEN3
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+2) <='0';--SD14
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+4) <= SDIO0_CLK_IN;--SD1_CLK
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+5) <='0';--ARM_TRST
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(22*(2**C_MUX_WIDTH)+7) <='0';--
  --          22                     
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(22);
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+1) <='1';--<reserved>/GPIO_GEN3
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+2) <='1';--SD14
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+4) <='0';--SD1_CLK
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+5) <='1';--ARM_TRST
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(22*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(23);
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+1) <='0';--<reserved> /GPIO_GEN4
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+2) <='0';--SD15
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+4) <= SDIO0_CMD_O_IN;--SD1_CMD
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+5) <='0';--ARM_RTCK
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(23*(2**C_MUX_WIDTH)+7) <='0';--
  --          23                     
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(23);
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+1) <='1';--<reserved> /GPIO_GEN4
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+2) <='1';--SD15
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+4) <= SDIO0_CMD_T_IN;--SD1_CMD
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+5) <='1';--ARM_RTCK
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(23*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(24);
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+1) <='0';--<reserved> / GPIO_GEN5
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+2) <='0';--SD16
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_O_IN(0);--SD1_DAT0
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+5) <='0';--ARM_TDO
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(24*(2**C_MUX_WIDTH)+7) <='0';--
  --          24                     
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(24);
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+1) <='1';--<reserved> / GPIO_GEN5
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+2) <='1';--SD16
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_T_IN(0);--SD1_DAT0
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+5) <='1';--ARM_TDO
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(24*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(25);
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+1) <='0';--<reserved> / GPIO_GEN6
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+2) <='0';--SD17
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_O_IN(1);--SD1_DAT1
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+5) <='0';--ARM_TCK
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(25*(2**C_MUX_WIDTH)+7) <='0';--
  --          25                     
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(25);
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+1) <='1';--<reserved> / GPIO_GEN6
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+2) <='1';--SD17
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_T_IN(1);--SD1_DAT1
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+5) <='1';--ARM_TCK
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(25*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(26);
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+1) <='0';--<reserved> / nc
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+2) <='0';--<reserved>
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_O_IN(2);--SD1_DAT2
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+5) <='0';--ARM_TDI
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(26*(2**C_MUX_WIDTH)+7) <='0';--
  --          26                     
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(26);
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+1) <='1';--<reserved> / nc
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+2) <='1';--<reserved>
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_T_IN(2);--SD1_DAT2
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+5) <='1';--ARM_TDI
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(26*(2**C_MUX_WIDTH)+7) <='1';--

  ---------------------
  --gpio
  --          GIO               MUX
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+0) <= EMIO_O_IN(27);
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+1) <='0';--<reserved> /GPIO_GEN2 / CAM_GPIO
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+2) <='0';--<reserved>
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+3) <='0';--<reserved>
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_O_IN(3);--SD1_DAT3
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+5) <='0';--ARM_TMS
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+6) <='0';--
  mux_usr_o_i(27*(2**C_MUX_WIDTH)+7) <='0';--
  --          27                     
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+0) <= EMIO_T_IN(27);
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+1) <='1';--<reserved> /GPIO_GEN2 / CAM_GPIO
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+2) <='1';--<reserved>
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+3) <='1';--<reserved>
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+4) <= SDIO0_DATA_T_IN(3);--SD1_DAT3
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+5) <='1';--ARM_TMS
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+6) <='1';--
  mux_usr_t_i(27*(2**C_MUX_WIDTH)+7) <='1';--
end generate;
-------------------------------------------------------------------

end Behavioral;