
# Loading additional proc with user specified bodies to compute parameter values.
source [file join [file dirname [file dirname [info script]]] gui/rpi_gpio_v1_0.gtcl]

# Definitional proc to organize widgets for parameters.
proc init_gui { IPINST } {
  ipgui::add_param $IPINST -name "Component_Name"
  #Adding Page
  set Page_0 [ipgui::add_page $IPINST -name "Page 0"]
  #Adding Group
  set Multiplexer_Configuration [ipgui::add_group $IPINST -name "Multiplexer Configuration" -parent ${Page_0}]
  ipgui::add_param $IPINST -name "C_BOARD_VARIANT" -parent ${Multiplexer_Configuration} -widget comboBox
  ipgui::add_param $IPINST -name "C_MODI" -parent ${Multiplexer_Configuration} -widget comboBox
  set C_STATIC_MUX_VALUE [ipgui::add_param $IPINST -name "C_STATIC_MUX_VALUE" -parent ${Multiplexer_Configuration}]
  set_property tooltip {Every 8 bit configures one IO.  LSBs are Port 0 ...} ${C_STATIC_MUX_VALUE}

  #Adding Group
  set IO_Configuration [ipgui::add_group $IPINST -name "IO Configuration" -parent ${Page_0} -display_name {Input Configuration}]
  set C_EMIO_WIDTH [ipgui::add_param $IPINST -name "C_EMIO_WIDTH" -parent ${IO_Configuration}]
  set_property tooltip {Should be smaller or equal GPIO Width} ${C_EMIO_WIDTH}

  #Adding Group
  set Ouput_Configuration [ipgui::add_group $IPINST -name "Ouput Configuration" -parent ${Page_0}]
  set_property tooltip {GPIO_H ((C_GPIO_H_Width)+15:15) GPIO_L (15:0)} ${Ouput_Configuration}
  set C_EXCLUDE_UART0 [ipgui::add_param $IPINST -name "C_EXCLUDE_UART0" -parent ${Ouput_Configuration} -widget comboBox]
  set_property tooltip {GPIO_L(15:14) will be disabled} ${C_EXCLUDE_UART0}
  set C_EXCLUDE_I2C0 [ipgui::add_param $IPINST -name "C_EXCLUDE_I2C0" -parent ${Ouput_Configuration} -widget comboBox]
  set_property tooltip {GPIO_L(1:0) will be disabled} ${C_EXCLUDE_I2C0}
  ipgui::add_param $IPINST -name "C_GPIO_H_WIDTH" -parent ${Ouput_Configuration}



}

proc update_PARAM_VALUE.C_STATIC_MUX_VALUE { PARAM_VALUE.C_STATIC_MUX_VALUE PARAM_VALUE.C_MODI } {
	# Procedure called to update C_STATIC_MUX_VALUE when any of the dependent parameters in the arguments change
	
	set C_STATIC_MUX_VALUE ${PARAM_VALUE.C_STATIC_MUX_VALUE}
	set C_MODI ${PARAM_VALUE.C_MODI}
	set values(C_MODI) [get_property value $C_MODI]
	if { [gen_USERPARAMETER_C_STATIC_MUX_VALUE_ENABLEMENT $values(C_MODI)] } {
		set_property enabled true $C_STATIC_MUX_VALUE
	} else {
		set_property enabled false $C_STATIC_MUX_VALUE
	}
}

proc validate_PARAM_VALUE.C_STATIC_MUX_VALUE { PARAM_VALUE.C_STATIC_MUX_VALUE } {
	# Procedure called to validate C_STATIC_MUX_VALUE
	return true
}

proc update_PARAM_VALUE.C_BOARD_VARIANT { PARAM_VALUE.C_BOARD_VARIANT } {
	# Procedure called to update C_BOARD_VARIANT when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_BOARD_VARIANT { PARAM_VALUE.C_BOARD_VARIANT } {
	# Procedure called to validate C_BOARD_VARIANT
	return true
}

proc update_PARAM_VALUE.C_EMIO_WIDTH { PARAM_VALUE.C_EMIO_WIDTH } {
	# Procedure called to update C_EMIO_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_EMIO_WIDTH { PARAM_VALUE.C_EMIO_WIDTH } {
	# Procedure called to validate C_EMIO_WIDTH
	return true
}

proc update_PARAM_VALUE.C_EXCLUDE_I2C0 { PARAM_VALUE.C_EXCLUDE_I2C0 } {
	# Procedure called to update C_EXCLUDE_I2C0 when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_EXCLUDE_I2C0 { PARAM_VALUE.C_EXCLUDE_I2C0 } {
	# Procedure called to validate C_EXCLUDE_I2C0
	return true
}

proc update_PARAM_VALUE.C_EXCLUDE_UART0 { PARAM_VALUE.C_EXCLUDE_UART0 } {
	# Procedure called to update C_EXCLUDE_UART0 when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_EXCLUDE_UART0 { PARAM_VALUE.C_EXCLUDE_UART0 } {
	# Procedure called to validate C_EXCLUDE_UART0
	return true
}

proc update_PARAM_VALUE.C_GPIO_H_WIDTH { PARAM_VALUE.C_GPIO_H_WIDTH } {
	# Procedure called to update C_GPIO_H_WIDTH when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_GPIO_H_WIDTH { PARAM_VALUE.C_GPIO_H_WIDTH } {
	# Procedure called to validate C_GPIO_H_WIDTH
	return true
}

proc update_PARAM_VALUE.C_MODI { PARAM_VALUE.C_MODI } {
	# Procedure called to update C_MODI when any of the dependent parameters in the arguments change
}

proc validate_PARAM_VALUE.C_MODI { PARAM_VALUE.C_MODI } {
	# Procedure called to validate C_MODI
	return true
}


proc update_MODELPARAM_VALUE.C_BOARD_VARIANT { MODELPARAM_VALUE.C_BOARD_VARIANT PARAM_VALUE.C_BOARD_VARIANT } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_BOARD_VARIANT}] ${MODELPARAM_VALUE.C_BOARD_VARIANT}
}

proc update_MODELPARAM_VALUE.C_MODI { MODELPARAM_VALUE.C_MODI PARAM_VALUE.C_MODI } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_MODI}] ${MODELPARAM_VALUE.C_MODI}
}

proc update_MODELPARAM_VALUE.C_STATIC_MUX_VALUE { MODELPARAM_VALUE.C_STATIC_MUX_VALUE PARAM_VALUE.C_STATIC_MUX_VALUE } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_STATIC_MUX_VALUE}] ${MODELPARAM_VALUE.C_STATIC_MUX_VALUE}
}

proc update_MODELPARAM_VALUE.C_EMIO_WIDTH { MODELPARAM_VALUE.C_EMIO_WIDTH PARAM_VALUE.C_EMIO_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_EMIO_WIDTH}] ${MODELPARAM_VALUE.C_EMIO_WIDTH}
}

proc update_MODELPARAM_VALUE.C_GPIO_H_WIDTH { MODELPARAM_VALUE.C_GPIO_H_WIDTH PARAM_VALUE.C_GPIO_H_WIDTH } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_GPIO_H_WIDTH}] ${MODELPARAM_VALUE.C_GPIO_H_WIDTH}
}

proc update_MODELPARAM_VALUE.C_EXCLUDE_I2C0 { MODELPARAM_VALUE.C_EXCLUDE_I2C0 PARAM_VALUE.C_EXCLUDE_I2C0 } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_EXCLUDE_I2C0}] ${MODELPARAM_VALUE.C_EXCLUDE_I2C0}
}

proc update_MODELPARAM_VALUE.C_EXCLUDE_UART0 { MODELPARAM_VALUE.C_EXCLUDE_UART0 PARAM_VALUE.C_EXCLUDE_UART0 } {
	# Procedure called to set VHDL generic/Verilog parameter value(s) based on TCL parameter value
	set_property value [get_property value ${PARAM_VALUE.C_EXCLUDE_UART0}] ${MODELPARAM_VALUE.C_EXCLUDE_UART0}
}

